import React from 'react';
import ListItem from './ListItem';
import PropTypes from 'prop-types';
import IIIFParser from '../services/iiif-parser';

var iiifParser = new IIIFParser();

var List = function List(props) {
  return React.createElement(
    'ul',
    null,
    props.items.map(function (item) {
      var filteredItem = iiifParser.filterVisibleRangeItem(item);
      if (!filteredItem) {
        return null;
      }
      return React.createElement(ListItem, { key: filteredItem.id, item: filteredItem });
    })
  );
};

List.propTypes = process.env.NODE_ENV !== "production" ? {
  items: PropTypes.array.isRequired
} : {};

export default List;