function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { connect } from 'react-redux';
import * as actions from '../actions';
import hlsjs from 'hls.js';
import 'mediaelement';
import PropTypes from 'prop-types';

// Import stylesheet and shims
import 'mediaelement/build/mediaelementplayer.min.css';

var MediaElement = function (_Component) {
  _inherits(MediaElement, _Component);

  function MediaElement(props) {
    _classCallCheck(this, MediaElement);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};
    return _this;
  }

  MediaElement.prototype.success = function success(media, node, instance) {
    // Your action when media was successfully loaded
    console.log('Loaded successfully');

    // Action reducer
    this.props.playerInitialized(instance);
  };

  MediaElement.prototype.error = function error(media) {
    // Your action when media had an error loading
    console.log('Error loading');
  };

  MediaElement.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _global = global,
        MediaElementPlayer = _global.MediaElementPlayer;


    if (!MediaElementPlayer) {
      return;
    }

    var options = Object.assign({}, JSON.parse(this.props.options), {
      pluginPath: './static/media/',
      success: function success(media, node, instance) {
        return _this2.success(media, node, instance);
      },
      error: function error(media, node) {
        return _this2.error(media, node);
      }
    });

    window.Hls = hlsjs;
    this.setState({ player: new MediaElementPlayer(this.props.id, options) });
  };

  MediaElement.prototype.componentWillUnmount = function componentWillUnmount() {
    if (this.state.player) {
      this.state.player.remove();
      this.setState({ player: null });
    }
  };

  MediaElement.prototype.render = function render() {
    var props = this.props,
        sources = JSON.parse(props.sources),
        sourceTags = [],
        tracksTags = [];

    for (var i = 0, total = sources.length; i < total; i++) {
      var source = sources[i];
      sourceTags.push('<source src="' + source.src + '" type="' + source.type + '">');
    }

    var mediaBody = sourceTags.join('\n') + '\n\t\t\t\t' + tracksTags.join('\n'),
        mediaHtml = props.mediaType === 'video' ? '<video id="' + props.id + '" width="' + props.width + '" height="' + props.height + '"' + (props.poster ? ' poster=' + props.poster : '') + '\n\t\t\t\t\t' + (props.controls ? ' controls' : '') + (props.preload ? ' preload="' + props.preload + '"' : '') + '>\n\t\t\t\t\t' + mediaBody + '\n\t\t\t\t</video>' : '<audio id="' + props.id + '" width="' + props.width + '" controls>\n\t\t\t\t\t' + mediaBody + '\n\t\t\t\t</audio>';

    return React.createElement('div', { dangerouslySetInnerHTML: { __html: mediaHtml } });
  };

  return MediaElement;
}(Component);

MediaElement.propTypes = process.env.NODE_ENV !== "production" ? {
  id: PropTypes.string,
  mediaType: PropTypes.string,
  preload: PropTypes.string,
  width: PropTypes.number,
  height: PropTypes.number,
  poster: PropTypes.string,
  sources: PropTypes.string,
  options: PropTypes.string
} : {};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    playerInitialized: function playerInitialized(player) {
      return dispatch(actions.playerInitialized(player));
    }
  };
};

export default connect(null, mapDispatchToProps)(MediaElement);