'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ListItem = require('./ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _iiifParser = require('../services/iiif-parser');

var _iiifParser2 = _interopRequireDefault(_iiifParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iiifParser = new _iiifParser2.default();

var List = function List(props) {
  return _react2.default.createElement(
    'ul',
    null,
    props.items.map(function (item) {
      var filteredItem = iiifParser.filterVisibleRangeItem(item);
      if (!filteredItem) {
        return null;
      }
      return _react2.default.createElement(_ListItem2.default, { key: filteredItem.id, item: filteredItem });
    })
  );
};

List.propTypes = process.env.NODE_ENV !== "production" ? {
  items: _propTypes2.default.array.isRequired
} : {};

exports.default = List;
module.exports = exports['default'];