'use strict';

exports.__esModule = true;

var _types = require('../actions/types');

var types = _interopRequireWildcard(_types);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var initialState = {
  error: false,
  loading: false
};

var getManifest = function getManifest() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case types.FETCH_MANIFEST_REQUEST:
      return Object.assign({}, state, {
        error: false,
        loading: true,
        manifest: null,
        url: action.payload
      });
    case types.FETCH_MANIFEST_SUCCESS:
      return Object.assign({}, state, {
        error: false,
        loading: false,
        manifest: action.payload
      });
    case types.FETCH_MANIFEST_FAILURE:
      return Object.assign({}, state, {
        error: action.payload,
        loading: false,
        manifest: null,
        url: null
      });
    default:
      return state;
  }
};

exports.default = getManifest;
module.exports = exports['default'];